class Blocks implements Shape {
  color dColor, dColor2;
  int dTeeth;
  int dColumns;
  boolean dCheckered;
  int minXSize, minYSize, maxXSize, maxYSize;

  //Blocks
  Blocks() {
    //defaults:
    dTeeth = 5;
    //    dColumns = l;
  } //Blocks

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {

    dColor = getCombColor();
    dColor2 = getCombColor();

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.noStroke();
      buffer.rect(0, 0, dWidth, dHeight);
    }

    buffer.fill(dColor);
    buffer.noStroke();

    float leftWidth = min(20, float(dWidth) / 6.0);
    leftWidth = max(leftWidth, 8);
    //    rect(0, 0, leftWidth, dHeight);

    //    dTeeth =  int(dHeight / 20);

    float toothYDivision = float(dHeight) / float(dTeeth);
    float toothHeight = toothYDivision * 0.76;
    float makeupWidth = (toothYDivision * 0.14) / (dTeeth - 1);
    float toothYPos = 0.0;

    dColumns = int(dWidth / (toothHeight * 1.5));
    dCheckered = random(1) > 0.66;
    
    int teethLimited = int(random(dTeeth - 1)) + 2;
    
    //normal
    for (int i=0; i<teethLimited; i++) {
      for (int j=0; j<dColumns; j++) {
        toothYPos = toothYDivision * i + (makeupWidth * i);
        //        rect(0, toothYPos, dWidth, toothHeight);
        //        rect

        if (i%2==0 &&
          dCheckered) {
          buffer.fill(dColor2);
        } 
        else {
          buffer.fill(dColor);
        }
        buffer.noStroke();
        buffer.rect((toothHeight * 1.2) * j + int(random(3)), toothYPos +  (j*0.05 * toothHeight), toothHeight * (1.0 - j*0.1), toothHeight * (1.0 - j*0.1));
      }
    }
    buffer.strokeWeight(1);


    buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}
